/*
(c) 2010 Perttu Ahola <celeron55@gmail.com>
*/

#ifndef MAPNODE_HEADER
#define MAPNODE_HEADER

#include <iostream>
#include "common_irrlicht.h"

// Size of node in rendering units
#define BS 10

#define MATERIALS_COUNT 4

// This is the common material through which the player can walk
// and the light can propagate
#define MATERIAL_AIR 254
// This is completely ignored. It doesn't create faces with anything.
#define MATERIAL_IGNORE 255

#define LIGHT_MAX 1.0
#define LIGHT_MIN 0.0
// If lighting value is under this, it can be assumed that
// there is no light
#define NO_LIGHT_MAX 0.03

typedef f32 light_t;

struct MapNode
{
	//TODO: block type to differ from material (e.g. grass edges)
	u8 d; // block type
	light_t light;
	//u8 flags;

	MapNode(const MapNode & n)
	{
		*this = n;
	}
	
	MapNode(u8 data=MATERIAL_AIR, light_t a_light=LIGHT_MIN)
	//MapNode(u8 data=MATERIAL_AIR, light_t a_light=LIGHT_MAX)
	{
		d = data;
		light = a_light;
		/*flags = a_flags;*/
	}

	/*
		If true, the node allows light propagation
	*/
	inline bool transparent()
	{
		return (d == MATERIAL_AIR);
	}
};



#endif

