/*
(c) 2010 Perttu Ahola <celeron55@gmail.com>
*/

#ifndef MAPNODE_HEADER
#define MAPNODE_HEADER

#include <iostream>
#include "common_irrlicht.h"
#include "light.h"

// Size of node in rendering units
#define BS 10

#define MATERIALS_COUNT 4

// This is completely ignored. It doesn't create faces with anything.
#define MATERIAL_IGNORE 255
// This is the common material through which the player can walk
// and which is transparent to light
#define MATERIAL_AIR 254

enum Material
{
	MATERIAL_STONE=0,
	MATERIAL_GRASS,
	MATERIAL_TORCH,

	USEFUL_MATERIAL_COUNT
};

struct MapNode
{
	//TODO: block type to differ from material (e.g. grass edges)
	u8 d; // block type
	light_t light;
	//u8 flags;

	MapNode(const MapNode & n)
	{
		*this = n;
	}
	
	MapNode(u8 data=MATERIAL_AIR, light_t a_light=LIGHT_MIN)
	//MapNode(u8 data=MATERIAL_AIR, light_t a_light=LIGHT_MAX)
	{
		d = data;
		light = a_light;
		/*flags = a_flags;*/
	}

	/*
		If true, the node allows light propagation
	*/
	inline bool transparent()
	{
		return (d == MATERIAL_AIR || d == MATERIAL_TORCH);
	}

	inline light_t light_source()
	{
		if(d == MATERIAL_TORCH)
			return 0.9;
		
		return 0.0;
	}
};



#endif

