#ifndef ENVIRONMENT_HEADER
#define ENVIRONMENT_HEADER

/*
	This class is the game's environment.
	It contains:
	- The map
	- Players
	- Other objects
	- The current time in the game, etc.
*/

#include <list>
#include "common_irrlicht.h"
#include "player.h"
#include "map.h"

class Environment
{
public:
	Environment();
	~Environment();
	void step(f32 dtime);
	Map & getMap();
	/*
		Environment deallocates players after use.
	*/
	void addPlayer(Player *player);
	void removePlayer(Player *player);
private:
	Map m_map;
	core::list<Player*> m_players;
};

#endif

