#ifndef UTILITY_HEADER
#define UTILITY_HEADER

template <typename T>
class SharedPtr
{
public:
	SharedPtr(T *t)
	{
		assert(t != NULL);
		refcount = new int;
		*refcount = 1;
		ptr = t;
	}
	SharedPtr(SharedPtr<T> &t)
	{
		*this = t;
	}
	~SharedPtr()
	{
		(*refcount)--;
		if(*refcount == 0)
		{
			delete refcount;
			delete ptr;
		}
	}
	SharedPtr<T> & operator=(SharedPtr<T> &t)
	{
		refcount = t.refcount;
		(*refcount)++;
		ptr = t.ptr;
		return *this;
	}
	T* operator->()
	{
		return ptr;
	}
	T & operator*()
	{
		return *ptr;
	}
private:
	T *ptr;
	int *refcount;
};

template <typename T>
class Buffer
{
public:
	Buffer(unsigned int size)
	{
		m_size = size;
		data = new T[size];
	}
	Buffer(Buffer &buffer)
	{
		m_size = buffer.m_size;
		data = new T[buffer.m_size];
		memcpy(data, buffer.data, buffer.m_size);
	}
	Buffer(T *t, unsigned int size)
	{
		m_size = size;
		data = new T[size];
		memcpy(data, t, size);
	}
	~Buffer()
	{
		delete[] data;
	}
	T & operator[](unsigned int i)
	{
		return data[i];
	}
	T * operator*()
	{
		return data;
	}
	unsigned int getSize()
	{
		return m_size;
	}
private:
	T *data;
	unsigned int m_size;
};

#endif

