#ifndef LIGHT_HEADER
#define LIGHT_HEADER

#include "common_irrlicht.h"

// This directly sets the range of light
#define LIGHT_MAX 15

#define LIGHT_SUN (LIGHT_MAX + 1)

inline u8 diminish_light(u8 light)
{
	if(light == 0)
		return 0;
	if(light >= LIGHT_MAX)
		return LIGHT_MAX - 1;
		
	return light - 1;
}

inline u8 undiminish_light(u8 light)
{
	// We don't know if light should undiminish from this particular 0.
	// Thus, keep it at 0.
	if(light == 0)
		return 0;
	if(light == LIGHT_MAX)
		return light;
	
	return light + 1;
}

u8 decode_light(u8 light);

#endif

