#ifndef SERIALIZATION_HEADER
#define SERIALIZATION_HEADER

#include "common_irrlicht.h"
#include "exceptions.h"

/*
	Serialization format versions:
	0: original networked test with 1-byte nodes
	1: update with 2-byte nodes
	2: lighting is transmitted in param
*/
// This represents an uninitialized or invalid format
#define SER_FMT_VER_INVALID 255
// Highest supported serialization version
#define SER_FMT_VER_HIGHEST 2
// Lowest supported serialization version
#define SER_FMT_VER_LOWEST 0

#define ser_ver_supported(v) (v >= SER_FMT_VER_LOWEST && v <= SER_FMT_VER_HIGHEST)

// There is no benefits in using this kind of thing and it
// makes using serializedLength as it can't be static.
/*class Serializable
{
public:
	virtual u32 serializedLength(u8 version)
	{
		throw NotImplementedException("serializedLength() stub called");
	}
	virtual void serialize(u8 *dest, u8 version)
	{
		throw NotImplementedException("serialize() stub called");
	}
	virtual void deSerialize(u8 *source, u8 version)
	{
		throw NotImplementedException("deSerialize() stub called");
	}
};*/

#endif

