#ifndef CLIENTSERVER_HEADER
#define CLIENTSERVER_HEADER

#define PROTOCOL_ID 0x4f457403

enum ToClientCommand
{
	TOCLIENT_INIT=0x10,
	/*
		Server's reply to TOSERVER_INIT.
		Sent second after connected.

		[0] u16 TOSERVER_INIT
		[2] u8 deployed version
		[3] v3s16 player's position + v3f(0,BS/2,0) floatToInt'd
	*/

	TOCLIENT_BLOCKDATA=0x20, //TODO: Multiple blocks
	TOCLIENT_ADDNODE,
	TOCLIENT_REMOVENODE,
	TOCLIENT_PLAYERPOS,
	TOCLIENT_PLAYERINFO,
	TOCLIENT_OPT_BLOCK_NOT_FOUND, // Not used

	TOCLIENT_SECTORMETA,
	/*
		[0] u16 command
		[2] u8 sector count
		[3...] v2s16 pos + sector metadata
	*/

	TOCLIENT_INVENTORY,
	/*
		[0] u16 command
		[2] serialized inventory
	*/
};

enum ToServerCommand
{
	TOSERVER_INIT=0x10,
	/*
		Sent first after connected.

		[0] u16 TOSERVER_INIT
		[2] u8 SER_FMT_VER_HIGHEST
		[3] u8[20] player_name
	*/

	TOSERVER_INIT2,
	/*
		Sent as an ACK for TOCLIENT_INIT.
		After this, the server can send data.

		[0] u16 TOSERVER_INIT2
	*/

	TOSERVER_GETBLOCK=0x20, // Not used
	TOSERVER_ADDNODE,
	TOSERVER_REMOVENODE,
	TOSERVER_PLAYERPOS,

	TOSERVER_GOTBLOCKS,
	/*
		[0] u16 command
		[2] u8 count
		[3] v3s16 pos_0
		[3+6] v3s16 pos_1
		...
	*/

	TOSERVER_DELETEDBLOCKS,
	/*
		[0] u16 command
		[2] u8 count
		[3] v3s16 pos_0
		[3+6] v3s16 pos_1
		...
	*/

	TOSERVER_ADDNODE_FROM_INVENTORY,
	/*
		[0] u16 command
		[2] v3s16 pos
		[8] u16 i
	*/
};

// Flags for TOSERVER_GETBLOCK
#define TOSERVER_GETBLOCK_FLAG_OPTIONAL (1<<0)

#endif

